/***********************************************************************/
/*                                                                     */
/*   SVMTorch                                                          */
/*                                                                     */
/*   Author: Ronan Collobert                                           */
/*   Date: 21.07.2000                                                  */
/*                                                                     */
/*   Copyright (c) 2000  IDIAP - All rights reserved                   */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/
  

#ifndef HEAPSORT_INC
#define HEAPSORT_INC

/**********************************************************************
 * All procedures uses a heap sort method.
 */

/* Sort the <size> first elements of <index>[] tabular
 * in ascending order, with <data>[<index>[]] as a criterion.
 */
void r_indexedAscendingSort(int *index, real *data, int size);

/* The same, but in descending order.
 */
void r_indexedDescendingSort(int *index, real *data, int size);

/* Try to insert <the_index> in <index>[] tabular if
 * <data>[<the_index>] has a upper value than 
 * <data>[index[0..<K>-1]] values.
 * If it is inserted, the worst value of <index>[] is removed.
 */
void r_handleIndexedKBestSort(int the_index, int *index, real *data, int K);

/* The same : just replace "upper" by "lower".
 *                     and "worst" by "best".
 */
void r_handleIndexedKWorstSort(int the_index, int *index, real *data, int K);

/* En entiers [BOEUF LEVEL = VERY HIGH]
 */


void i_indexedAscendingSort(int *index, int *data, int size);
void i_indexedDescendingSort(int *index, int *data, int size);
void i_handleIndexedKBestSort(int the_index, int *index, int *data, int K);
void i_handleIndexedKWorstSort(int the_index, int *index, int *data, int K);


#endif
