/***********************************************************************/
/*                                                                     */
/*   SVMTorch                                                          */
/*                                                                     */
/*   Author: Ronan Collobert                                           */
/*   Date: 21.07.2000                                                  */
/*                                                                     */
/*   Copyright (c) 2000  IDIAP - All rights reserved                   */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/
  

#include "chunker.h"


void analyticSolve(void)
{
	real y1 = Y_SP[0];
	real y2 = Y_SP[1];
	real s = y1*y2;
	real *ptr;
	real k11, k12, k22;
	real d = y1*alpha_new[0] + y2*alpha_new[1];
	real L, H, ww, eta, alph;

	ptr = K_SP;
	k11 = *ptr++;
	k12 = *ptr++;
	k22 = *(ptr+1);

	/* L, H ?
	 */
	if(s < 0)
	{
		ww = alpha_new[0] - alpha_new[1];
		L = ((ww   > 0.0) ? ww :  0.0);
		H = ((C+ww >   C) ? C  : C+ww);
	}
	else
	{
		ww = alpha_new[0] + alpha_new[1];
		L = ((ww-C > 0.0) ? ww-C : 0.0);
		H = ((ww   >   C) ? C    :  ww);
	}

	eta = k11 - 2*k12 + k22;

	if(eta > 0)
	{
		alph = ((k22 - k12)*y1*d + b_SP[0] - b_SP[1]*s)/eta;
	
		if(alph > H)
			alph = H;
		else
		{
			if(alph < L)
				alph = L;
		}
    
		alpha_new[0] = alph;
		alpha_new[1] = y2*d - s*alph;
	}
	else
	{
		alph = (k12 - k22)*y1*d + b_SP[1] - b_SP[0]*s;
		if(alph > 0)
		{
			alpha_new[0] = L;
			alpha_new[1] = y2*d - s*L;
		}
		else
		{
			alpha_new[0] = H;
			alpha_new[1] = y2*d - s*H;
		}
	}
}
