/***********************************************************************/
/*                                                                     */
/*   SVMTorch                                                          */
/*                                                                     */
/*   Author: Ronan Collobert                                           */
/*   Date: 21.07.2000                                                  */
/*                                                                     */
/*   Copyright (c) 2000  IDIAP - All rights reserved                   */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/
  

#ifndef INC_SVM
#define INC_SVM

#include "general.h"
#include "chunker.h"

typedef struct
{
		int n_s_v;
		int *support_vectors;

		real *points;
		real *alpha;
		real *Y;
		real b;
		
		int n;
		int w;

} SVM;

SVM *initSVM(void);
void destroySVM(SVM *svm);
void createFileAsciiSVM(SVM *svm, char *fc);
void createFileBinSVM(SVM *svm, char *fc);
void checkSVM(SVM *svm);
void learnSVM(SVM *svm);
void svSVM(SVM *svm);
void saveFileAsciiSVM(SVM *svm, char *fc);
void saveFileBinSVM(SVM *svm, char *fc);

#endif
